package ConcurrentFramework;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

public class ForkJoinFibonacciDemo {
	
	public static int fib(int n) {

	    return n <= 1 ? n : fib(n - 1) + fib(n - 2);
	    
	}

	public static void main(String[] args) throws InterruptedException, ExecutionException {
		
		int N = 35;
		Fibonacci fibonacci = new Fibonacci(N);
	    ForkJoinPool.commonPool().execute(fibonacci);
	    
	    new Thread(() -> { 
		    long t0 = System.nanoTime();
		    System.out.println(fib(N));
		    long t1 = System.nanoTime();
		    System.out.println(Thread.currentThread() + ": " + (t1 - t0) / 1e6 + "ms");
	    }).start();
	    
	    new Thread(() -> {
			try {
				long t0 = System.nanoTime();
				System.out.println(fibonacci.get());
				long t1 = System.nanoTime();
				System.out.println(Thread.currentThread() + ": " + (t1 - t0) / 1e6 + "ms");
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
		}).start();
	    
	}
	
	public static class Fibonacci extends RecursiveTask<Integer> {
		
	    final int n;
	    Fibonacci(int n) { this.n = n; }

	    public Integer compute() {
	    	
	        if (n <= 1) return n;
	        
	        Fibonacci f1 = new Fibonacci(n - 1);
	        f1.fork();
	        Fibonacci f2 = new Fibonacci(n - 2);
	        
	        return f2.compute() + f1.join();
	    }
	}

}
