package ConcurrentFramework;

import java.util.concurrent.Phaser;

public class LongRunningActionDemo implements Runnable {
	
	private String threadName;
	private Phaser ph;
	
	LongRunningActionDemo(String threadName, Phaser ph) {
		
		this.threadName = threadName;
		this.ph = ph;
		ph.register();
		
	}
	
	@Override
	public void run() {
		
		System.out.println("This is phase " + ph.getPhase() + ".");
		System.out.println("Thread " + threadName + " before long running action.");
		
		ph.arriveAndAwaitAdvance();
		
		try {
			Thread.sleep(20);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		ph.arriveAndDeregister();
		
	}
	
	public static void main(String[] args) {
		
		new Thread(new LongRunningActionDemo("GO", new Phaser())).start();
		
	}
}