package ConcurrentFramework;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;

// https://docs.oracle.com/javase/8/docs/api/java/util/concurrent/Executors.html
// https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/ExecutorService.html
// https://docs.oracle.com/javase/8/docs/api/java/util/concurrent/atomic/AtomicInteger.html

public class ThreadPoolDemo {
	
//	public static int data = 0;
	public static AtomicInteger data = new AtomicInteger(0);
	
	public static void main(String[] args) throws InterruptedException {
		
		ExecutorService pool = Executors.newFixedThreadPool(2);
		Runnable task = () -> {
			for (int i = 0; i < 100; i ++) {
//				data++;
				data.getAndIncrement();
				System.out.println(Thread.currentThread() + ": " + data);
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
				}
			}
			System.out.println("Done.");
		};
		
		pool.execute(task);
		pool.execute(task);
		
		pool.shutdown();

	}

}
