package ConcurrentFramework;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

// https://docs.oracle.com/javase/7/docs/api/java/util/concurrent/Callable.html
// https://docs.oracle.com/javase/8/docs/api/java/util/concurrent/BlockingQueue.html

public class ThreadPoolDemo2 {
		
	public static void main(String[] args) throws InterruptedException, ExecutionException {
		
		ExecutorService pool = Executors.newFixedThreadPool(4);
		Callable<String> task1 = () -> {
			Thread.sleep((int) (Math.random() * 10000));
			return "Java Programming 2: ";
		};
		
		Callable<String> task2 = () -> {
			Thread.sleep((int) (Math.random() * 10000));
			return "Concurrent Framework";
		};

		Future<String> f1 = pool.submit(task1);
		Future<String> f2 = pool.submit(task2);
		
		pool.execute(() -> {
			try {
				System.out.println(f1.get());
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			} catch (ExecutionException e1) {
				e1.printStackTrace();
			}
		});
		
		pool.execute(() -> {
			try {
				System.out.println(f2.get());
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			} catch (ExecutionException e1) {
				e1.printStackTrace();
			}
		});
		
		try {
			for (int i = 1; i <= 10; i++) {
				Thread.sleep(1000);
				System.out.println(Thread.currentThread() + " working ... " + i);
			}
		} catch (Exception e) {
			
		}
		
		pool.shutdown();

	}

}
